CREATE OR REPLACE TYPE SALES_CUST_TYPE AS OBJECT
(
 PROD_COUNT NUMBER(5),
 CHANNEL_COUNT NUMBER(2),      
 AMOUNT_TOT NUMBER 
);
/

explain plan for
SELECT s.cust_id, s.cust_year_of_birth, 
       s.sales_cust.prod_count,
       s.sales_cust.channel_count, 
       s.sales_cust.amount_tot
  FROM (SELECT c.cust_id, c.cust_year_of_birth,
               (SELECT sales_cust_type
                          (COUNT (DISTINCT s.prod_id), 
                           COUNT (DISTINCT s.channel_id),
                           SUM (s.amount_sold)
                          )
                  FROM sales s
                 WHERE s.cust_id = c.cust_id) AS sales_cust
          FROM customers c
         WHERE c.cust_year_of_birth= 1987) s ;   
         
         
select * from table(dbms_xplan.display);
	
	
	
------------------------------------------------------
Oracle 8.1.7  

CREATE OR REPLACE TYPE sales_cust_type AS OBJECT (
   prod_count      NUMBER (5),
   channel_count   NUMBER (2),      
   amount_tot      NUMBER
);
/
   
CREATE OR REPLACE TYPE array_sales_cust AS VARRAY (1) OF sales_cust_type; 
/

SELECT c.cust_id, c.cust_year_of_birth, s.prod_count, s.channel_count, s.amount_tot
  FROM (SELECT c.cust_id, c.cust_year_of_birth,
               CAST (MULTISET(SELECT COUNT (DISTINCT s.prod_id) AS prod_count,
                                     COUNT (DISTINCT s.channel_id) AS channel_count,
                                     SUM (s.amount_sold) AS amount_tot
                                FROM sales s
                               WHERE s.cust_id = c.cust_id
                             ) AS array_sales_cust 
                    ) AS sales_cust                
          FROM customers c
WHERE c.cust_year_of_birth= 1987) c,
      TABLE (sales_cust) s ; 
